/*! gcip-iap v2.0.0 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),require("whatwg-fetch"),require("url-polyfill"),require("promise-polyfill");var extendStatics=function(e,t){return extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var a in t)t.hasOwnProperty(a)&&(e[a]=t[a])},extendStatics(e,t)};function __extends(e,t){function a(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(a.prototype=t.prototype,new a)}var IP_ADDRESS_REGEXP=/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;function isArray(e){return Array.isArray(e)}function isString(e){return"string"==typeof e}function isNonEmptyString(e){return isString(e)&&""!==e}function isObject(e){return"object"==typeof e&&!isArray(e)}function isNonNullObject(e){return isObject(e)&&null!==e}function isAuthorizedDomain(e,t){var a=new URL(t),r=a.protocol,n=a.hostname,o=!1;return e.forEach(function(e){matchDomain(e,n,r)&&(o=!0)}),o}function matchDomain(e,t,a){if("http:"!==a&&"https:"!==a)return!1;if(IP_ADDRESS_REGEXP.test(e))return t===e;var r=e.split(".").join("\\."),n=new RegExp("^(.+\\."+r+"|"+r+")$","i");return n.test(t)}function isURL(e){if("string"!=typeof e)return!1;if(/[^a-z0-9\:\/\?\#\[\]\@\!\$\&\'\(\)\*\+\,\;\=\.\-\_\~\%]/i.test(e))return!1;try{var t=new URL(e),a=t.protocol,r=t.hostname,n=t.pathname;if("http:"!==a&&"https:"!==a)return!1;if(!/^[a-zA-Z0-9]+[\w\-]*([\.]?[a-zA-Z0-9]+[\w\-]*)*$/.test(r))return!1;if(n&&!/^\/+$/.test(n)&&!/^(\/+[\w\-\.\~\!\$\'\(\)\*\+\,\;\=\:\@\%]+)*\/*$/.test(n))return!1}catch(t){return!1}return!0}function isLocalhostOrHttpsURL(e){if(isURL(e)){var t=new URL(e);return"http:"===t.protocol&&"localhost"===t.hostname||"https:"===t.protocol}return!1}function isEmail(e){if("string"!=typeof e)return!1;return /^[^@]+@[^@]+$/.test(e)}function isProviderId(e){if("string"!=typeof e)return!1;return isNonEmptyString(e)&&/^[a-zA-Z0-9\-\_\.]+$/.test(e)}var SAFE_URL_PATTERN=/^(?:(?:https?|mailto|ftp):|[^:/?#]*(?:[/?#]|$))/i,INNOCUOUS_STRING="about:invalid";function addReadonlyGetter(e,t,a){Object.defineProperty(e,t,{value:a,writable:!1,enumerable:!0})}function removeUndefinedFields(e){if(!isNonNullObject(e))return e;for(var t in e)"undefined"==typeof e[t]&&delete e[t];return e}function formatString(e,t){var a=e;return Object.keys(t||{}).forEach(function(e){a=a.replace(new RegExp("{"+e+"}","g"),t[e])}),a}function getCurrentUrl(e){return e&&e.location&&e.location.href||null}function setCurrentUrl(e,t){e.location.assign(sanitizeUrl(t))}function runIfDefined(e,t,a){if(void 0===a&&(a=[]),"function"==typeof e)return e.apply(t,a)}function generateRandomAlphaNumericString(e){for(var t=Math.floor,a=[],r="1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";0<e;)a.push(r.charAt(t(Math.random()*r.length))),e--;return a.join("")}function mapObject(e,t){var a={};return Object.keys(e).forEach(function(r){a[r]=t(r,e[r])}),a}function onDomReady(e){return new Promise(function(t){"loading"===e.readyState?e.addEventListener("DOMContentLoaded",function(){t()}):t()})}function sanitizeUrl(e){return isSafeUrl(e)?e:INNOCUOUS_STRING}function isSafeUrl(e){return SAFE_URL_PATTERN.test(e)}function isHistorySupported(e){return void 0===e&&(e=window),!!(e.history&&e.history.pushState)}function isCustomEventSupported(e){return void 0===e&&(e=window),e.hasOwnProperty("CustomEvent")}function isHistoryAndCustomEventSupported(e){return void 0===e&&(e=window),isHistorySupported(e)&&isCustomEventSupported(e)}function pushHistoryState(e,t,a,r){isHistorySupported(e)&&e.history.pushState(t,a,r)}function getHistoryState(e){return void 0===e&&(e=window),isHistorySupported(e)?e.history.state:null}function isIframe(e){void 0===e&&(e=window);try{return!!(e&&e!==e.top)}catch(t){return!1}}function isCrossOriginIframe(e){if(void 0===e&&(e=window),isIframe(e))try{return e.parent.location.hostname!==e.location.hostname||e.parent.location.protocol!==e.location.protocol}catch(t){return!0}return!1}function deepCopy(e){return deepExtend(void 0,e)}function deepEqual(e,t){if(e===t)return!0;if("object"==typeof e&&"object"==typeof t&&null!==e&&null!==t&&Object.keys(e).length===Object.keys(t).length){for(var a in e)if(e.hasOwnProperty(a)&&(!t.hasOwnProperty(a)||!deepEqual(e[a],t[a])))return!1;return!0}return!1}function deepExtend(e,t){if(!(t instanceof Object))return t;switch(t.constructor){case Date:return new Date(t.getTime());case Object:e===void 0&&(e={});break;case Array:e=[];break;default:return t}for(var a in t)t.hasOwnProperty(a)&&(e[a]=deepExtend(e[a],t[a]));return e}var RECOVERABLE_ERROR_CODES=["aborted","resource-exhausted","cancelled","unknown","deadline-exceeded","unavailable","auth/timeout","auth/too-many-requests","auth/quota-exceeded","auth/network-request-failed"],CIAPError=function(e){function t(a,r,n){var o=e.call(this,r||a.message)||this;return o.errorInfo=a,o.underlyingReason=n,Object.setPrototypeOf(o,t.prototype),o}return __extends(t,e),Object.defineProperty(t.prototype,"code",{get:function(){return this.errorInfo.code},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"message",{get:function(){return this.errorInfo.message},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"reason",{get:function(){return this.underlyingReason},enumerable:!1,configurable:!0}),t.prototype.toJSON=function(){var e={code:this.code,message:this.message};return"undefined"!=typeof this.underlyingReason&&deepExtend(e,{reason:JSON.stringify(this.underlyingReason)}),e},t}(Error),HttpCIAPError=function(e){function t(a,r,n,o){var s=e.call(this,t.getErrorInfo(a,r,n),void 0,o)||this;return s.httpErrorCode=a,Object.setPrototypeOf(s,t.prototype),s}return __extends(t,e),t.getErrorInfo=function(e,t,a){for(var r in HTTP_ERROR_CODE)if(HTTP_ERROR_CODE.hasOwnProperty(r)&&HTTP_ERROR_CODE[r].status===t)return{code:reformatStatusCode(HTTP_ERROR_CODE[r].status),message:a||HTTP_ERROR_CODE[r].message};for(var r in HTTP_ERROR_CODE)if(HTTP_ERROR_CODE.hasOwnProperty(r)&&HTTP_ERROR_CODE[r].code===e)return{code:reformatStatusCode(t||HTTP_ERROR_CODE[r].status),message:a||HTTP_ERROR_CODE[r].message};return{code:reformatStatusCode(t||HTTP_ERROR_CODE.unknown.status),message:a||HTTP_ERROR_CODE.unknown.message}},t.prototype.toJSON=function(){return deepExtend(e.prototype.toJSON.call(this),{httpErrorCode:this.httpErrorCode})},t}(CIAPError);function isRecoverableError(e){return-1!==RECOVERABLE_ERROR_CODES.indexOf(e.code)}function reformatStatusCode(e){return e.toLowerCase().replace(/_/g,"-")}var StorageType,HTTP_ERROR_CODE={"invalid-argument":{code:400,status:"INVALID_ARGUMENT",message:"Client specified an invalid argument."},"failed-precondition":{code:400,status:"FAILED_PRECONDITION",message:"Request can not be executed in the current system state."},"out-of-range":{code:400,status:"OUT_OF_RANGE",message:"Client specified an invalid range."},unauthenticated:{code:401,status:"UNAUTHENTICATED",message:"Request not authenticated due to missing, invalid, or expired OAuth token"},"permission-denied":{code:403,status:"PERMISSION_DENIED",message:"Client does not have sufficient permission."},"not-found":{code:404,status:"NOT_FOUND",message:"Specified resource is not found."},aborted:{code:409,status:"ABORTED",message:"Concurrency conflict, such as read-modify-write conflict."},"already-exists":{code:409,status:"ALREADY_EXISTS",message:"The resource that a client tried to create already exists."},"resource-exhausted":{code:429,status:"RESOURCE_EXHAUSTED",message:"Either out of resource quota or reaching rate limiting."},cancelled:{code:499,status:"CANCELLED",message:"Request cancelled by the client."},"data-loss":{code:500,status:"DATA_LOSS",message:"Unrecoverable data loss or data corruption."},unknown:{code:500,status:"UNKNOWN",message:"Unknown server error."},internal:{code:500,status:"INTERNAL",message:"Internal server error."},"not-implemented":{code:501,status:"NOT_IMPLEMENTED",message:"API method not implemented by the server."},unavailable:{code:503,status:"UNAVAILABLE",message:"Service unavailable."},"deadline-exceeded":{code:504,status:"DEADLINE_EXCEEDED",message:"Request deadline exceeded."}},CLIENT_ERROR_CODES=mapObject(HTTP_ERROR_CODE,function(e){return{code:reformatStatusCode(HTTP_ERROR_CODE[e].status),message:HTTP_ERROR_CODE[e].message}});(function(e){e.Local="LOCAL",e.Session="SESSION",e.None="NONE"})(StorageType||(StorageType={}));var STORAGE_AVAILABLE_KEY="__sak";function isStorageAvailable(e){try{var t=STORAGE_AVAILABLE_KEY+generateRandomAlphaNumericString(10),a="1";return(e.setItem(t,a),e.getItem(t)===a)&&(e.removeItem(t),!0)}catch(t){return!1}}var BrowserName,AbstractStorage=function(){function e(e){if(this.storage=e,!isStorageAvailable(e))throw new CIAPError(CLIENT_ERROR_CODES["failed-precondition"],"Requested storage is not available")}return e.prototype.set=function(e,t){var a=this;return Promise.resolve().then(function(){a.storage.setItem(e,JSON.stringify(t))})},e.prototype.get=function(e){var t=this;return Promise.resolve().then(function(){var a=t.storage.getItem(e);if(null!==a)try{return JSON.parse(a)}catch(t){}})},e.prototype.remove=function(e){var t=this;return Promise.resolve().then(function(){t.storage.removeItem(e)})},e.prototype.clear=function(){return this.storage.clear(),Promise.resolve()},e}(),LocalStorage=function(e){function t(t){return e.call(this,t.localStorage)||this}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return StorageType.Local},enumerable:!1,configurable:!0}),t}(AbstractStorage),SessionStorage=function(e){function t(t){return e.call(this,t.sessionStorage)||this}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return StorageType.Session},enumerable:!1,configurable:!0}),t}(AbstractStorage),InMemoryStorage=function(){function e(){this.storageMap={}}return Object.defineProperty(e.prototype,"type",{get:function(){return StorageType.None},enumerable:!1,configurable:!0}),e.prototype.set=function(e,t){return this.storageMap[e]=t,Promise.resolve()},e.prototype.get=function(e){return Promise.resolve(this.storageMap[e])},e.prototype.remove=function(e){return delete this.storageMap[e],Promise.resolve()},e.prototype.clear=function(){var e=this;return Promise.resolve().then(function(){e.storageMap={}})},e}(),Factory=function(){function e(e){this.win=e}return e.prototype.makeStorage=function(e){return e===StorageType.Local?new LocalStorage(this.win):e===StorageType.Session?new SessionStorage(this.win):new InMemoryStorage},e}(),AUTH_TENANTS_DATA_STORAGE_INFO={name:"auth-tenants",type:StorageType.Local},AuthTenantsStorageManager=function(){function e(e,t){var a=this;this.storageManager=e,this.appId=t,this.queue=this.storageManager.get(AUTH_TENANTS_DATA_STORAGE_INFO,this.appId).then(function(e){a.tenantList=e||[]})}return e.prototype.listTenants=function(){var e=this;return this.addToQueue(function(){return Promise.resolve(e.tenantList.concat())})},e.prototype.removeTenant=function(e){var t=this;return this.addToQueue(function(){return t.tenantList=t.tenantList.filter(function(t){return t!==e}),t.save()})},e.prototype.addTenant=function(e){var t=this;return this.addToQueue(function(){return-1===t.tenantList.indexOf(e)?(t.tenantList.push(e),t.save()):Promise.resolve()})},e.prototype.clearTenants=function(){var e=this;return this.addToQueue(function(){return 0<e.tenantList.length?(e.tenantList=[],e.save()):Promise.resolve()})},e.prototype.save=function(){return this.tenantList.length?this.storageManager.set(AUTH_TENANTS_DATA_STORAGE_INFO,this.tenantList,this.appId):this.storageManager.remove(AUTH_TENANTS_DATA_STORAGE_INFO,this.appId)},e.prototype.addToQueue=function(e){var t=this.queue.then(e);return this.queue=t.catch(function(){}),t},e}(),NAMESPACE="ciap",SEPARATOR=":",StorageManager=function(){function e(t){try{this.persistenceStorage=t.makeStorage(StorageType.Local),this.temporaryStorage=t.makeStorage(StorageType.Session)}catch(a){this.persistenceStorage=t.makeStorage(StorageType.None),this.temporaryStorage=t.makeStorage(StorageType.None)}this.inMemoryStorage=t.makeStorage(StorageType.None)}return e.prototype.get=function(e,t){return this.getStorage(e.type).get(this.getKeyName(e,t))},e.prototype.set=function(e,t,a){return this.getStorage(e.type).set(this.getKeyName(e,a),t)},e.prototype.remove=function(e,t){return this.getStorage(e.type).remove(this.getKeyName(e,t))},e.prototype.getStorage=function(e){return e===StorageType.Local?this.persistenceStorage:e===StorageType.Session?this.temporaryStorage:this.inMemoryStorage},e.prototype.getKeyName=function(e,t){var a=isNonEmptyString(t)?""+SEPARATOR+t:"";return""+NAMESPACE+SEPARATOR+e.name+a},e}(),globalStorageManager=new StorageManager(new Factory(window)),PromiseCache=function(){function e(){this.cachedPromises={}}return e.prototype.cacheAndReturnResult=function(e,t,a,r){var n=this;"undefined"==typeof e._cid_&&(e._cid_=generateRandomAlphaNumericString(10));var o=e._cid_;if("undefined"!=typeof this.cachedPromises[o]&&this.cachedPromises[o].cb===e&&this.cachedPromises[o].thisArg===t&&this.cachedPromises[o].expirationTime>new Date().getTime()&&this.cachedPromises[o].args.length===a.length){for(var s=!0,d=0;d<a.length;d++)if(!deepEqual(a[d],this.cachedPromises[o].args[d])){s=!1;break}if(s)return this.cachedPromises[o].promise}delete this.cachedPromises[o];var l=e.apply(t,a).catch(function(e){throw delete n.cachedPromises[o],e});return this.cachedPromises[o]={promise:l,cb:e,thisArg:t,args:deepCopy(a),expirationTime:new Date().getTime()+r},l},e.prototype.clear=function(e){if("undefined"==typeof e)this.cachedPromises={};else{var t=e._cid_;"undefined"!=typeof t&&delete this.cachedPromises[t]}},e}(),ApiRequester=function(){function e(e){this.baseConfig=e,this.setRequestValidator(null),this.setResponseValidator(null)}return e.prototype.process=function(e,t,a,r,n){var o=this;void 0===t&&(t=null),void 0===a&&(a=null),void 0===r&&(r=null),void 0===n&&(n=null);var s=deepCopy(this.baseConfig);return t&&(s.url=formatString(s.url,t)),a&&(isObject(s.data)&&isObject(a)?deepExtend(s.data,a):s.data=a),r&&(!s.headers&&(s.headers={}),deepExtend(s.headers,r)),null!==n&&(s.timeout=n),Promise.resolve().then(function(){return o.requestValidator(s),e.send(s)}).then(function(e){return o.responseValidator(e),e})},e.prototype.setRequestValidator=function(e){return this.requestValidator=e||function(){},this},e.prototype.setResponseValidator=function(e){return this.responseValidator=e||function(){},this},e}();(function(e){e.Android="Android",e.Blackberry="Blackberry",e.Edge="Edge",e.Firefox="Firefox",e.IE="IE",e.IEMobile="IEMobile",e.Opera="Opera",e.Other="Other",e.Chrome="Chrome",e.Safari="Safari",e.Silk="Silk",e.Webos="Webos"})(BrowserName||(BrowserName={}));function getBrowserName(e){var t=e.toLowerCase();if(-1!==t.indexOf("opera/")||-1!==t.indexOf("opr/")||-1!==t.indexOf("opios/"))return BrowserName.Opera;if(-1!==t.indexOf("iemobile"))return BrowserName.IEMobile;if(-1!==t.indexOf("msie")||-1!==t.indexOf("trident/"))return BrowserName.IE;if(-1!==t.indexOf("edge/"))return BrowserName.Edge;if(-1!==t.indexOf("firefox/"))return BrowserName.Firefox;if(-1!==t.indexOf("silk/"))return BrowserName.Silk;if(-1!==t.indexOf("blackberry"))return BrowserName.Blackberry;if(-1!==t.indexOf("webos"))return BrowserName.Webos;if(-1!==t.indexOf("safari/")&&-1===t.indexOf("chrome/")&&-1===t.indexOf("crios/")&&-1===t.indexOf("android"))return BrowserName.Safari;if((-1!==t.indexOf("chrome/")||-1!==t.indexOf("crios/"))&&-1===t.indexOf("edge/"))return BrowserName.Chrome;if(-1!==t.indexOf("android"))return BrowserName.Android;var a=e.match(/([a-zA-Z\d\.]+)\/[a-zA-Z\d\.]*$/);return a&&2===a.length?a[1]:BrowserName.Other}function getUserAgentString(){return window&&window.navigator&&window.navigator.userAgent||""}function isMobileBrowser(e){var t=e||getUserAgentString(),a=t.toLowerCase();return!!(a.match(/android/)||a.match(/webos/)||a.match(/iphone|ipad|ipod/)||a.match(/blackberry/)||a.match(/windows phone/)||a.match(/iemobile/))}function getClientVersion(e,t){return getBrowserName(e||getUserAgentString())+"/CIAP/2.0.0"+("undefined"==typeof t?"":"/"+t)}var GCIP_TIMEOUT,GCIP_HOST="www.googleapis.com",GCIP_PATH="/identitytoolkit/v3/relyingparty/",GCIP_HEADERS={"Content-Type":"application/json","X-Client-Version":getClientVersion()};(function(e){e[e.Short=3e4]="Short",e[e.Long=6e4]="Long"})(GCIP_TIMEOUT||(GCIP_TIMEOUT={}));var IAP_TIMEOUT,GCIPRequestHandler=function(){function e(e,t,a){if(this.apiKey=e,this.httpClient=t,this.framework=a,!isNonEmptyString(e))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid API key");if(!t||"function"!=typeof t.send)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid HTTP client instance");this.timeout=isMobileBrowser()?GCIP_TIMEOUT.Long:GCIP_TIMEOUT.Short}return e.prototype.checkAuthorizedDomainsAndGetProjectId=function(t){var a=this;return Promise.resolve().then(function(){t.forEach(function(e){if(!isURL(e))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid URL")});var r="undefined"==typeof a.framework?null:{"X-Client-Version":getClientVersion(void 0,a.framework)};return e.GET_PROJECT_CONFIG.process(a.httpClient,{apiKey:a.apiKey},null,r,a.timeout).then(function(e){var a=e.data;return t.forEach(function(e){if(!isAuthorizedDomain(a.authorizedDomains,e))throw new CIAPError(CLIENT_ERROR_CODES["permission-denied"],"Unauthorized domain: "+e)}),a.projectId}).catch(function(e){throw a.translateLowLevelError(e)})})},e.prototype.translateLowLevelError=function(e){if("status"in e){var t=void 0,a=void 0,r=e.response;if(r&&r.data&&r.data.error&&r.data.error.message){var n=r.data;if(isNonEmptyString(n.error.status))t=n.error.status,a=n.error.message;else{var o=(n.error.message||"").split(":");t=1<o.length?o[0].trim():n.error.message,a=1<o.length?o[1].trim():void 0}}return new HttpCIAPError(e.status,t,a,e)}return e},e.GET_PROJECT_CONFIG=new ApiRequester({method:"GET",mode:"cors",cache:"no-cache",headers:GCIP_HEADERS,url:"https://www.googleapis.com"+GCIP_PATH+"getProjectConfig?key={apiKey}"}).setResponseValidator(function(e){if(!e.isJson()||!isArray(e.data.authorizedDomains)||!isNonEmptyString(e.data.projectId))throw new CIAPError(CLIENT_ERROR_CODES.unknown,"Invalid response")}),e}();(function(e){e[e.Short=3e4]="Short",e[e.Long=6e4]="Long"})(IAP_TIMEOUT||(IAP_TIMEOUT={}));var GCIP_ERROR_CODES,IAP_HEADERS={"Content-Type":"application/json"},XSRF_CHECK_NEEDED="XsrfNonceCheckIsNeeded",IAP_ERROR_CODE={8:"AUTHENTICATION_URI_FAIL",37:"GCIP_TOKEN_INVALID",38:"RESOURCE_MISSING_GCIP_SIGN_IN_URL",39:"GCIP_REDIRECT_INVALID",40:"GET_PROJECT_MAPPING_FAIL",41:"GCIP_ID_TOKEN_ENCRYPTION_ERROR",42:"GCIP_ID_TOKEN_DECRYPTION_ERROR",43:"GCIP_ID_TOKEN_UNESCAPE_ERROR"};(function(e){e.RestartProcess="RESTART_PROCESS"})(GCIP_ERROR_CODES||(GCIP_ERROR_CODES={}));var GCIP_ERROR_OVERRIDE={FAILED_PRECONDITION:{messagePattern:/restart\sthe\sauthentication\sprocess/,newCode:GCIP_ERROR_CODES.RestartProcess}},IAPRequestHandler=function(){function e(e){if(this.httpClient=e,!e||"function"!=typeof e.send)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid HTTP client instance");this.timeout=isMobileBrowser()?IAP_TIMEOUT.Long:IAP_TIMEOUT.Short}return e.prototype.exchangeIdTokenAndGetOriginalAndTargetUrl=function(t,a,r){var n=this;return e.EXCHANGE_ID_TOKEN.process(this.httpClient,{iapRedirectServerUrl:t},{id_token:a,state:r},null,this.timeout).then(function(e){return e.data}).catch(function(e){throw n.translateLowLevelCanonicalError(e)})},e.prototype.setCookieAtTargetUrl=function(t,a){var r=this;return e.SET_COOKIE.process(this.httpClient,{targetUrl:t},null,{"x-iap-3p-token":a},this.timeout).then(function(e){return e.data===XSRF_CHECK_NEEDED}).catch(function(e){throw r.translateLowLevelTextError(e)})},e.prototype.getSessionInfo=function(t,a){var r=this;return e.GET_SESSION_INFO.process(this.httpClient,{iapRedirectServerUrl:t},{state:a},null,this.timeout).then(function(e){return e.data}).catch(function(e){throw r.translateLowLevelCanonicalError(e)})},e.prototype.translateLowLevelCanonicalError=function(e){if("status"in e){var t=void 0,a=void 0,r=e.response;if(r&&r.data&&r.data.error&&r.data.error.status){var n=r.data;if(t=n.error.status,a=n.error.details&&n.error.details.length&&n.error.details[0]&&n.error.details[0].detail,GCIP_ERROR_OVERRIDE.hasOwnProperty(t)){var o=new RegExp(GCIP_ERROR_OVERRIDE[t].messagePattern),s=n.error.message;o.test(s)&&(t=GCIP_ERROR_OVERRIDE[t].newCode,a=s)}}return new HttpCIAPError(e.status,t,a,e)}return e},e.prototype.translateLowLevelTextError=function(e){if("status"in e){var t=void 0,a=void 0,r=e.response;if(r&&r.data&&(t=r.data,isNonEmptyString(t))){var n=t.match(/Error\s(\d+)\scode/);1<n.length&&"undefined"!=typeof IAP_ERROR_CODE[n[1]]&&(a=IAP_ERROR_CODE[n[1]])}return new HttpCIAPError(e.status,a,t,e)}return e},e.EXCHANGE_ID_TOKEN=new ApiRequester({method:"POST",mode:"cors",cache:"no-cache",headers:IAP_HEADERS,url:"{iapRedirectServerUrl}"}).setRequestValidator(function(e){if(!isSafeUrl(e.url)||!isLocalhostOrHttpsURL(e.url))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid URL");if(!isNonEmptyString(e.data.id_token)||!isNonEmptyString(e.data.state))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid request")}).setResponseValidator(function(e){if(!e.isJson()||!isNonEmptyString(e.data.redirectToken)||!isNonEmptyString(e.data.originalUri)||!isNonEmptyString(e.data.targetUri)||!isSafeUrl(e.data.originalUri)||!isSafeUrl(e.data.targetUri))throw new CIAPError(CLIENT_ERROR_CODES.unknown,"Invalid response")}),e.SET_COOKIE=new ApiRequester({method:"GET",mode:"cors",cache:"no-cache",headers:IAP_HEADERS,credentials:"include",url:"{targetUrl}"}).setRequestValidator(function(e){if(!isSafeUrl(e.url)||!isLocalhostOrHttpsURL(e.url))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid URL");if(!isNonEmptyString(e.headers["x-iap-3p-token"]))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid request")}),e.GET_SESSION_INFO=new ApiRequester({method:"POST",mode:"cors",cache:"no-cache",headers:IAP_HEADERS,url:"{iapRedirectServerUrl}"}).setRequestValidator(function(e){if(!isSafeUrl(e.url)||!isLocalhostOrHttpsURL(e.url))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid URL");if(!isNonEmptyString(e.data.state))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid request")}).setResponseValidator(function(e){if(!e.isJson()||!isNonEmptyString(e.data.originalUri)||!isSafeUrl(e.data.originalUri)||!isArray(e.data.tenantIds))throw new CIAPError(CLIENT_ERROR_CODES.unknown,"Invalid response")}),e}();function sendRequest(e){var t,a,r=e.url,n=new Headers(e.headers),o=n.get("content-type");if(e.data)if("GET"===e.method||"HEAD"===e.method){if(!isNonNullObject(e.data))return Promise.reject(new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],e.method+" requests cannot have a body."));var s=new URL(e.url),i=e.data;for(var d in i)i.hasOwnProperty(d)&&s.searchParams.append(d,i[d]);r=s.toString()}else a=o&&o.toLowerCase().includes("application/x-www-form-urlencoded")?Object.keys(e.data).map(function(t){return encodeURIComponent(t)+"="+encodeURIComponent(e.data[t])}).join("&"):JSON.stringify(e.data);var l=removeUndefinedFields({method:e.method,mode:e.mode,cache:e.cache,headers:e.headers,credentials:e.credentials,body:a});return new Promise(function(a,n){var s;return e.timeout&&(s=window.setTimeout(function(){n(new CIAPError(CLIENT_ERROR_CODES["deadline-exceeded"],"Error while making request: timeout of "+e.timeout+"ms exceeded"))},e.timeout)),fetch(r,l).then(function(e){return window.clearTimeout(s),t=e,o=e.headers.get("content-type"),o&&o.toLowerCase().includes("application/json")?e.json():e.text()}).then(function(r){a({status:t.status,headers:t.headers,config:e,request:l,data:r})}).catch(function(e){window.clearTimeout(s),n(e)})})}function createLowLevelError(e,t,a,r,n){var o=new Error(e);return addReadonlyGetter(o,"status",t),addReadonlyGetter(o,"config",a),addReadonlyGetter(o,"request",r),addReadonlyGetter(o,"response",n),o}var OperationType,DefaultHttpResponse=function(){var e=Math.floor;function t(t){if(this.status=t.status,this.headers=t.headers,this.request=t.request,200!=100*e(this.status/100))throw createLowLevelError("Server responded with status "+t.status,t.status,t.config,t.request,t);isObject(t.data)?(this.parsedData=t.data,this.text=JSON.stringify(t.data)):this.text=t.data}return Object.defineProperty(t.prototype,"data",{get:function(){return this.isJson()?this.parsedData:this.text},enumerable:!1,configurable:!0}),t.prototype.isJson=function(){return"undefined"!=typeof this.parsedData},t}(),HttpClient=function(){function e(){}return e.prototype.send=function(e){return sendRequest(e).then(function(e){return new DefaultHttpResponse(e)})},e}(),SharedSettings=function(){function e(e,t){this.apiKey=e;var a=new HttpClient;this.cache=new PromiseCache,this.gcipRequest=new GCIPRequestHandler(e,a,t),this.iapRequest=new IAPRequestHandler(a)}return e}();(function(e){e.SignIn="SIGN_IN",e.SignOut="SIGN_OUT",e.SelectAuthSession="SELECT_AUTH_SESSION"})(OperationType||(OperationType={}));var CacheDuration;(function(e){e[e.CheckAuthorizedDomains=18e5]="CheckAuthorizedDomains",e[e.ExchangeIdToken=3e5]="ExchangeIdToken",e[e.GetOriginalUrl=3e5]="GetOriginalUrl",e[e.GetSessionInfo=3e5]="GetSessionInfo",e[e.SetCookie=3e5]="SetCookie"})(CacheDuration||(CacheDuration={}));var ConfigMode,GCIP_IAP_FRAMEWORK_ID="gcip-iap",BaseOperationHandler=function(){function e(e,t,a){this.config=e,this.handler=t,a||(a=new SharedSettings(e.apiKey)),this.gcipRequest=a.gcipRequest,this.iapRequest=a.iapRequest,this.cache=a.cache,this.realTenantId=this.getRealTenantId(this.config.tid),this.auth=this.getAuth(this.config.tid),this.redirectUrl=e.redirectUrl,this.tenantId=e.tid,this.state=e.state,this.languageCode=e.hl,this.progressBarVisible=!1}return e.prototype.getOriginalURL=function(){return this.state&&this.redirectUrl?this.getSessionInformation().then(function(e){return e.originalUri}):Promise.resolve(null)},e.prototype.start=function(){var e=this;return this.showProgressBar(),new Promise(function(t,a){var r=function(){window.removeEventListener("popstate",n,!0)},n=function(){e.hideProgressBar(),r(),Promise.resolve().then(t)};return window.addEventListener("popstate",n,!0),e.validateAppAndGetProjectId().then(function(t){if(e.projectId=t,e.tenantId&&!e.realTenantId&&"_"+t!==e.tenantId)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Mismatching project numbers");return e.authTenantsStorageManager||(e.authTenantsStorageManager=new AuthTenantsStorageManager(globalStorageManager,t)),e.process()}).then(function(){r(),t()}).catch(function(t){r(),e.hideProgressBar(),isRecoverableError(t)&&addReadonlyGetter(t,"retry",function(){return e.start()}),runIfDefined(e.handler.handleError,e.handler,[t]),a(t)})})},e.prototype.getSessionInformation=function(){return this.cache.cacheAndReturnResult(this.iapRequest.getSessionInfo,this.iapRequest,[this.redirectUrl,this.state],CacheDuration.GetSessionInfo)},e.prototype.validateAppAndGetProjectId=function(){var e=[],t=new URL(getCurrentUrl(window));return e.push(t.origin),this.redirectUrl&&e.push(this.redirectUrl),this.cache.cacheAndReturnResult(this.gcipRequest.checkAuthorizedDomainsAndGetProjectId,this.gcipRequest,[e],CacheDuration.CheckAuthorizedDomains)},e.prototype.getAuth=function(e){if(!e)return null;var t=this.handler.getAuth(this.config.apiKey,this.getRealTenantId(e));if(t&&t.app.options.apiKey!==this.config.apiKey)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"API key mismatch");try{t.INTERNAL.logFramework(GCIP_IAP_FRAMEWORK_ID)}catch(t){}return t},e.prototype.showProgressBar=function(){this.progressBarVisible||(this.progressBarVisible=!0,runIfDefined(this.handler.showProgressBar,this.handler))},e.prototype.hideProgressBar=function(){this.progressBarVisible&&(this.progressBarVisible=!1,runIfDefined(this.handler.hideProgressBar,this.handler))},e.prototype.isProgressBarVisible=function(){return this.progressBarVisible},e.prototype.listAuthTenants=function(){return this.checkAuthTenantsStorageManagerInitialized(),this.authTenantsStorageManager.listTenants()},e.prototype.removeAuthTenant=function(e){return this.checkAuthTenantsStorageManagerInitialized(),this.authTenantsStorageManager.removeTenant(e)},e.prototype.addAuthTenant=function(e){return this.checkAuthTenantsStorageManagerInitialized(),this.authTenantsStorageManager.addTenant(e)},e.prototype.clearAuthTenants=function(){return this.checkAuthTenantsStorageManagerInitialized(),this.authTenantsStorageManager.clearTenants()},e.prototype.userHasMatchingTenantId=function(e){return!((e.tenantId||this.realTenantId)&&e.tenantId!==this.realTenantId)},e.prototype.checkAuthTenantsStorageManagerInitialized=function(){if(!this.authTenantsStorageManager)throw new CIAPError(CLIENT_ERROR_CODES.internal,"Instance not started")},e.prototype.getRealTenantId=function(e){return e&&"_"===e.charAt(0)?null:e},e}(),SELECTED_TENANT_INFO_REGEXP=/#hint=([^;]*);(.*)$/;(function(e){e.Login="login",e.Reauth="reauth",e.Signout="signout",e.SelectAuthSession="selectAuthSession",e.Unknown="unknown"})(ConfigMode||(ConfigMode={}));var Config=function(){function e(e,t){this.parsedUrl=new URL(e),this.mode=this.getMode(this.parsedUrl.searchParams.get("mode")||""),this.apiKey=this.parsedUrl.searchParams.get("apiKey")||null,this.tid=this.parsedUrl.searchParams.get("tid")||null,this.redirectUrl=this.parsedUrl.searchParams.get("redirect_uri")||null,this.redirectUrl&&(this.redirectUrl=sanitizeUrl(this.redirectUrl)),this.state=this.parsedUrl.searchParams.get("state")||null,this.hl=this.parsedUrl.searchParams.get("hl")||null,this.selectedTenantInfo=this.getSelectedTenantInfo(this.parsedUrl.hash,t)}return e.prototype.getSelectedTenantInfo=function(e,t){var a=null;if(!this.tid)a=null;else if(t)a=t&&"signIn"===t.state?t.selectedTenantInfo:null;else if(e){var r=SELECTED_TENANT_INFO_REGEXP.exec(e);r&&1<r.length&&(a={email:r[1].trim(),providerIds:(r[2]||"").split(","),tenantId:this.tid})}if(a){var n,o=[];isEmail(a.email)||delete a.email,isArray(a.providerIds)?a.providerIds.forEach(function(e){isString(e)&&(n=e.trim(),isProviderId(n)&&o.push(n)),a.providerIds=o}):a.providerIds=[];var s=this.tid&&"_"===this.tid.charAt(0)?null:this.tid;a.tenantId!==s&&(a=null)}return a},e.prototype.getMode=function(e){return"login"===e?ConfigMode.Login:"reauth"===e?ConfigMode.Reauth:"signout"===e?ConfigMode.Signout:"selectAuthSession"===e?ConfigMode.SelectAuthSession:ConfigMode.Unknown},e}(),SelectAuthSessionOperationHandler=function(e){function t(t,a,r){var n=e.call(this,t,a,r)||this;if(!n.redirectUrl||!n.state)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid request");return n}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return OperationType.SelectAuthSession},enumerable:!1,configurable:!0}),t.prototype.process=function(){var e,t=this;return isCrossOriginIframe(window)?(this.hideProgressBar(),Promise.reject(new CIAPError(CLIENT_ERROR_CODES["permission-denied"],"The page is displayed in a cross origin iframe."))):this.getSessionInformation().then(function(e){var a={projectId:t.projectId,apiKey:t.config.apiKey};if(t.tenantIds=e.tenantIds.concat(),0===t.tenantIds.length)throw new CIAPError(CLIENT_ERROR_CODES.internal,"No tenants configured on resource.");return t.hideProgressBar(),"function"==typeof t.handler.selectTenant?t.handler.selectTenant(a,t.tenantIds):Promise.resolve({tenantId:e.tenantIds[0]})}).then(function(a){e=a;var r=a.tenantId||"_"+t.projectId;if(-1===t.tenantIds.indexOf(r))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Mismatching tenant ID");return r}).then(function(a){var r=new URL(getCurrentUrl(window)),n=r.protocol+"//"+r.host+r.pathname,o=encodeURIComponent(t.config.apiKey),s=encodeURIComponent(t.state),i=encodeURIComponent(t.redirectUrl),d=encodeURIComponent(a),l=n+"?mode="+ConfigMode.Login+"&apiKey="+o+"&tid="+d+"&state="+s+"&redirect_uri="+i;if(isHistoryAndCustomEventSupported(window)){var p={state:"signIn",selectedTenantInfo:e};pushHistoryState(window,p,window.document.title,l);var c=new CustomEvent("pushstate",{bubbles:!0,detail:{data:p}});return window.dispatchEvent(c),Promise.resolve()}var u=e.email||e.providerIds?"#hint="+e.email+";"+(e.providerIds||[]).join(","):"";t.showProgressBar(),setCurrentUrl(window,""+l+u)})},t}(BaseOperationHandler),FORCE_REFRESH_THRESHOLD=120000,REDIRECT_SERVER_TOKEN_QUERY_PARAM="rt",SignInOperationHandler=function(e){function t(t,a,r,n){void 0===n&&(n=!1);var o=e.call(this,t,a,r)||this;if(o.forceReauth=n,!o.auth||!o.redirectUrl||!o.state)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid request");return o}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return OperationType.SignIn},enumerable:!1,configurable:!0}),t.prototype.process=function(){var e=this;return this.getUser().then(function(t){if(t&&!e.forceReauth)return e.finishSignIn(t);if(isCrossOriginIframe(window))throw e.hideProgressBar(),new CIAPError(CLIENT_ERROR_CODES["permission-denied"],"The page is displayed in a cross origin iframe.");return e.startSignIn()})},t.prototype.getUser=function(){var e=this;return new Promise(function(t){var a=e.auth.onAuthStateChanged(function(r){a(),r&&e.userHasMatchingTenantId(r)?t(r):t(null)})})},t.prototype.processUser=function(e){var t=this,a=Promise.resolve(e);return"function"==typeof this.handler.processUser&&(a=this.handler.processUser(e)),a.then(function(e){if(t.userHasMatchingTenantId(e))return e;throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Mismatching tenant ID")})},t.prototype.startSignIn=function(){var e=this;return Promise.resolve().then(function(){return e.hideProgressBar(),e.handler.startSignIn(e.auth,e.config.selectedTenantInfo||void 0).then(function(t){if(e.showProgressBar(),!e.userHasMatchingTenantId(t.user))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Mismatching tenant ID");return e.finishSignIn(t.user)})})},t.prototype.finishSignIn=function(e){var t,a,r,n,o=this,s=!1;return this.processUser(e).then(function(e){return a=e,e.getIdTokenResult()}).then(function(e){var t=new Date(e.issuedAtTime).getTime(),r=new Date().getTime()-t;return r<=FORCE_REFRESH_THRESHOLD?e.token:a.getIdToken(!0)}).then(function(e){return o.cache.cacheAndReturnResult(o.iapRequest.exchangeIdTokenAndGetOriginalAndTargetUrl,o.iapRequest,[o.redirectUrl,e,o.state],CacheDuration.ExchangeIdToken)}).then(function(e){return t=e.originalUri,r=e.targetUri,n=e.redirectToken,o.cache.cacheAndReturnResult(o.iapRequest.setCookieAtTargetUrl,o.iapRequest,[e.targetUri,e.redirectToken],CacheDuration.SetCookie)}).then(function(e){return s=e,o.addAuthTenant(o.tenantId)}).then(function(){if(s){var e=new URL(r);e.searchParams.set(REDIRECT_SERVER_TOKEN_QUERY_PARAM,n),setCurrentUrl(window,e.toString())}else setCurrentUrl(window,t)}).catch(function(e){if("auth/user-disabled"===e.code||"auth/user-token-expired"===e.code)return o.removeAuthTenant(o.tenantId).then(function(){return o.startSignIn()});throw e})},t}(BaseOperationHandler),SignOutOperationHandler=function(e){function t(t,a,r){var n=e.call(this,t,a,r)||this;if(n.redirectUrl&&!n.state)throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid request");return n}return __extends(t,e),Object.defineProperty(t.prototype,"type",{get:function(){return OperationType.SignOut},enumerable:!1,configurable:!0}),t.prototype.process=function(){var e=this;return isCrossOriginIframe(window)?(this.hideProgressBar(),Promise.reject(new CIAPError(CLIENT_ERROR_CODES["permission-denied"],"The page is displayed in a cross origin iframe."))):this.signOut().then(function(){return e.state&&e.redirectUrl&&e.originalUri?void setCurrentUrl(window,e.originalUri):(e.hideProgressBar(),e.handler.completeSignOut())})},t.prototype.signOut=function(){var e=this;return this.state&&this.redirectUrl?this.getSessionInformation().then(function(t){var a=[];return e.originalUri=t.originalUri,t.tenantIds.forEach(function(t){var r=e.getAuth(t);r&&a.push(r.signOut().then(function(){return e.removeAuthTenant(t)}))}),Promise.all(a)}).then(function(){}):this.listAuthTenants().then(function(t){var a=[];return t.forEach(function(t){var r=e.getAuth(t);r&&a.push(r.signOut().then(function(){return e.removeAuthTenant(t)}))}),Promise.all(a)}).then(function(){return e.clearAuthTenants()})},t}(BaseOperationHandler);function isAuthenticationHandler(e){return!!(isNonNullObject(e)&&"function"==typeof e.getAuth&&"function"==typeof e.startSignIn&&"function"==typeof e.completeSignOut)&&("undefined"==typeof e.showProgressBar||"function"==typeof e.showProgressBar)&&("undefined"==typeof e.hideProgressBar||"function"==typeof e.hideProgressBar)&&("undefined"==typeof e.handleError||"function"==typeof e.handleError)&&("undefined"==typeof e.processUser||"function"==typeof e.processUser)&&("undefined"==typeof e.selectTenant||"function"==typeof e.selectTenant)}var Authentication=function(){function e(e,t,a){if(this.handler=e,!isAuthenticationHandler(e))throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid AuthenticationHandler");try{var r=new Config(getCurrentUrl(window),getHistoryState(window));this.sharedSettings=t&&t.apiKey===r.apiKey?t:new SharedSettings(r.apiKey,a);try{this.handler.languageCode=r.hl}catch(t){}switch(r.mode){case ConfigMode.Login:this.operationHandler=new SignInOperationHandler(r,e,this.sharedSettings);break;case ConfigMode.Reauth:this.operationHandler=new SignInOperationHandler(r,e,this.sharedSettings,!0);break;case ConfigMode.Signout:this.operationHandler=new SignOutOperationHandler(r,e,this.sharedSettings);break;case ConfigMode.SelectAuthSession:this.operationHandler=new SelectAuthSessionOperationHandler(r,e,this.sharedSettings);break;default:throw new CIAPError(CLIENT_ERROR_CODES["invalid-argument"],"Invalid mode")}}catch(e){this.fatalError=e}}return e.prototype.start=function(){var t,a=this,r=function(){t=new e(a.handler,a.sharedSettings)},n=function(){window.removeEventListener("popstate",r,!0),window.removeEventListener("pushstate",r,!0)};return onDomReady(window.document).then(function(){if(window.addEventListener("popstate",r,!0),window.addEventListener("pushstate",r,!0),"undefined"==typeof a.fatalError)return a.operationHandler.start().then(function(){if(n(),t)return t.start()});throw runIfDefined(a.handler.handleError,a.handler,[a.fatalError]),a.fatalError}).catch(function(e){throw n(),e})},e.prototype.getOriginalURL=function(){return this.operationHandler.getOriginalURL()},e}();exports.Authentication=Authentication;
